package com.supervision.knowsub.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.supervision.knowsub.vo.flow.BaseResVo;
import com.supervision.knowsub.vo.flow.FlowDetailResVo;
import com.supervision.knowsub.vo.flow.FlowInfoReqVo;
import com.supervision.knowsub.vo.flow.FlowInfoResVo;
import com.supervision.knowsub.vo.sublibrary.SubLibraryResVo;

import java.util.List;

public interface FlowManageService {
    String saveFlow(FlowInfoReqVo flowInfoReqVo);

    /**
     * 根据typeIds查询已经被使用的子库ids
     * @param typeIds
     * @return
     */
    List<String> listUsedBaseIds(List<Integer> typeIds);

    /**
     * 修改流程
     * @param flowInfoReqVo
     */
    void updateFlow(FlowInfoReqVo flowInfoReqVo);

    /**
     * 删除流程
     * @param id
     * @return
     */
    Boolean deleteFlow(String id);

    /**
     * 分页查询流程列表
     * @param flowName 流程名称
     * @param pageNum 页码
     * @param pageSize 每页大小
     * @return
     */
    IPage<FlowInfoResVo> pageListFlow(String flowName, Integer pageNum, Integer pageSize);

    /**
     * 查询可选择的子库信息列表
     * @param flowType 流程类型
     * @return
     */
    List<BaseResVo> optionalBaseList(List<Integer> flowType);

    /**
     * 查询流程详情
     * @param flowId 流程id
     * @return
     */
    FlowDetailResVo getFlowDetail(String flowId);
}
