package com.supervision.knowsub.dto.flow;

import com.supervision.knowsub.model.SystemFlowRule;
import com.supervision.knowsub.model.SystemFlowRuleUser;
import com.supervision.knowsub.vo.flow.NodeInfo;
import lombok.Data;

import java.util.List;

@Data
public class SystemFlowRuleDTO {

    private String id;

    private String flowId;

    private String ruleName;

    private Integer ruleOrder;

    private String roleId;

    private List<SystemFlowRuleUser> userList;

    public SystemFlowRuleDTO() {
    }

    public SystemFlowRule toSystemFlowRule() {
        SystemFlowRule systemFlowRule = new SystemFlowRule();
        systemFlowRule.setId(id);
        systemFlowRule.setFlowId(flowId);
        systemFlowRule.setRuleName(ruleName);
        systemFlowRule.setRuleOrder(ruleOrder);
        systemFlowRule.setRoleId(roleId);
        return systemFlowRule;
    }

    public List<SystemFlowRuleUser> toSystemFlowRuleUserList() {
        return userList;
    }

    public static SystemFlowRuleDTO builderWithNodeInfo(String flowId, NodeInfo nodeInfo) {
        SystemFlowRuleDTO systemFlowRuleDTO = new SystemFlowRuleDTO();
        systemFlowRuleDTO.setId(nodeInfo.getId());
        systemFlowRuleDTO.setRuleName(nodeInfo.getNodeName());
        systemFlowRuleDTO.setFlowId(flowId);
        systemFlowRuleDTO.setRuleOrder(nodeInfo.getOrder());
        systemFlowRuleDTO.setRoleId(nodeInfo.getRoleId());
        List<SystemFlowRuleUser> ruleUserList = nodeInfo.getUserIdList().stream().map(userId -> {
            SystemFlowRuleUser flowRuleUser = new SystemFlowRuleUser();
            flowRuleUser.setFlowId(flowId);
            flowRuleUser.setRuleId(nodeInfo.getId());
            flowRuleUser.setUserId(userId);
            return flowRuleUser;
        }).toList();
        systemFlowRuleDTO.setUserList(ruleUserList);
        return systemFlowRuleDTO;
    }
}
