package com.supervision.knowsub.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.supervision.knowsub.model.KnowledgeFlowRecord;
import com.baomidou.mybatisplus.extension.service.IService;
import com.supervision.knowsub.vo.knowledge.KnowledgeFlowResVO;

import java.time.Instant;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * @author Administrator
 * @description 针对表【ks_knowledge_flow_record(知识报送审批记录表)】的数据库操作Service
 * @createDate 2024-06-24 11:35:15
 */
public interface KnowledgeFlowRecordService extends IService<KnowledgeFlowRecord> {

    /**
     * 查询待办
     */
    IPage<KnowledgeFlowResVO> queryKnowledgeFlowTodoPage(String userId, String title, String publishDeptId, String baseId,
                                                         String submitDeptId, Instant flowType,
                                                         LocalDate publishDateBegin, LocalDate publishDateEnd,LocalDate submitDateBegin, LocalDate submitDateEnd,
                                                         Page<KnowledgeFlowResVO> page);

    /**
     * 查询已办
     */
    IPage<KnowledgeFlowResVO> queryKnowledgeFlowCompletePage(String userId, String title, String publishDeptId, String baseId,
                                                             String submitDeptId, Instant flowType,
                                                             LocalDate publishDateBegin, LocalDate publishDateEnd,LocalDate submitDateBegin, LocalDate submitDateEnd,
                                                             Page<KnowledgeFlowResVO> page);

    /**
     * 首页使用-查询用户审批通过的知识数量
     *
     * @param userId          用户ID
     * @param processStatus   审批的状态,通过或是不通过
     * @param knowledgeStatus 知识的状态
     */
    Long queryPassProcessCountByUser(String userId, Integer processStatus, Integer knowledgeStatus);

}
