package com.supervision.knowsub.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.supervision.knowsub.model.KnowledgeFlowRecord;
import com.supervision.knowsub.service.KnowledgeFlowRecordService;
import com.supervision.knowsub.mapper.KnowledgeFlowRecordMapper;
import com.supervision.knowsub.vo.knowledge.KnowledgeFlowResVO;
import org.springframework.stereotype.Service;

import java.time.Instant;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * @author Administrator
 * @description 针对表【ks_knowledge_flow_record(知识报送审批记录表)】的数据库操作Service实现
 * @createDate 2024-06-24 11:35:15
 */
@Service
public class KnowledgeFlowRecordServiceImpl extends ServiceImpl<KnowledgeFlowRecordMapper, KnowledgeFlowRecord>
        implements KnowledgeFlowRecordService {

    @Override
    public IPage<KnowledgeFlowResVO> queryKnowledgeFlowTodoPage(String userId, String title, String publishDeptId, String baseId, String submitDeptId, Instant flowType,
                                                                LocalDate publishDateBegin, LocalDate publishDateEnd, LocalDate submitDateBegin, LocalDate submitDateEnd,
                                                                Page<KnowledgeFlowResVO> page) {
        return this.baseMapper.queryKnowledgeFlowTodoPage(userId, title, publishDeptId, baseId, submitDeptId, flowType, publishDateBegin, publishDateEnd, submitDateBegin,submitDateEnd,page);
    }

    @Override
    public IPage<KnowledgeFlowResVO> queryKnowledgeFlowCompletePage(String userId, String title, String publishDeptId, String baseId, String submitDeptId, Instant flowType,
                                                                    LocalDate publishDateBegin, LocalDate publishDateEnd, LocalDate submitDateBegin, LocalDate submitDateEnd, Page<KnowledgeFlowResVO> page) {
        return this.baseMapper.queryKnowledgeFlowCompletePage(userId, title, publishDeptId, baseId, submitDeptId, flowType, publishDateBegin, publishDateEnd,submitDateBegin,submitDateEnd, page);
    }

    @Override
    public Long queryPassProcessCountByUser(String userId, Integer processStatus, Integer knowledgeStatus) {
        return this.baseMapper.queryPassProcessCountByUser(userId, processStatus, knowledgeStatus);
    }
}




